"""udpnecho."""


def main():
    """Execute udpnecho."""
    from fileinput import input
    from re import sub
    from sys import stdout
    from .pinyin2hanzi import DefaultHmmParams
    from .pinyin2hanzi import viterbi

    hmm = DefaultHmmParams()

    def f(x):
        data = x.group(0)
        data = [mapping[data[i:i+2]] for i in range(0, len(data), 2)]
        data = viterbi(hmm, data, 1)
        return ''.join(data[0].path)

    for line in input():
        stdout.write(sub(r'([a-z]{2})+', f, line))


mapping = {
    'aa': 'a',
    'ab': '',
    'ac': '',
    'ad': '',
    'ae': '',
    'af': '',
    'ag': '',
    'ah': 'ang',
    'ai': 'ai',
    'aj': '',
    'ak': '',
    'al': '',
    'am': '',
    'an': 'an',
    'ao': 'ao',
    'ap': '',
    'aq': '',
    'ar': '',
    'as': '',
    'at': '',
    'au': '',
    'av': '',
    'aw': '',
    'ax': '',
    'ay': '',
    'az': '',
    'ba': 'ba',
    'bb': '',
    'bc': 'biao',
    'bd': 'biang',
    'be': '',
    'bf': 'ben',
    'bg': 'beng',
    'bh': 'bang',
    'bi': 'bi',
    'bj': 'ban',
    'bk': 'bao',
    'bl': 'bai',
    'bm': 'bian',
    'bn': 'bin',
    'bo': 'bo',
    'bp': '',
    'bq': '',
    'br': '',
    'bs': '',
    'bt': '',
    'bu': 'bu',
    'bv': '',
    'bw': '',
    'bx': 'bie',
    'by': 'bing',
    'bz': 'bei',
    'ca': 'ca',
    'cb': 'cou',
    'cc': '',
    'cd': '',
    'ce': 'ce',
    'cf': 'cen',
    'cg': 'ceng',
    'ch': 'cang',
    'ci': 'ci',
    'cj': 'can',
    'ck': 'cao',
    'cl': 'cai',
    'cm': '',
    'cn': '',
    'co': 'cuo',
    'cp': 'cun',
    'cq': '',
    'cr': 'cuan',
    'cs': 'cong',
    'ct': '',
    'cu': 'cu',
    'cv': 'cui',
    'cw': '',
    'cx': '',
    'cy': '',
    'cz': '',
    'da': 'da',
    'db': 'dou',
    'dc': 'diao',
    'dd': 'diang',
    'de': 'de',
    'df': 'den',
    'dg': 'deng',
    'dh': 'dang',
    'di': 'di',
    'dj': 'dan',
    'dk': 'dao',
    'dl': 'dai',
    'dm': 'dian',
    'dn': 'din',
    'do': 'duo',
    'dp': 'dun',
    'dq': 'diu',
    'dr': 'duan',
    'ds': 'dong',
    'dt': '',
    'du': 'du',
    'dv': 'dui',
    'dw': 'dia',
    'dx': 'die',
    'dy': 'ding',
    'dz': 'dei',
    'ea': '',
    'eb': '',
    'ec': '',
    'ed': '',
    'ee': 'e',
    'ef': '',
    'eg': 'eng',
    'eh': '',
    'ei': 'ei',
    'ej': '',
    'ek': '',
    'el': '',
    'em': '',
    'en': 'en',
    'eo': '',
    'ep': '',
    'eq': '',
    'er': 'er',
    'es': '',
    'et': '',
    'eu': '',
    'ev': '',
    'ew': '',
    'ex': '',
    'ey': '',
    'ez': '',
    'fa': 'fa',
    'fb': 'fou',
    'fc': 'fiao',
    'fd': '',
    'fe': '',
    'ff': 'fen',
    'fg': 'feng',
    'fh': 'fang',
    'fi': '',
    'fj': 'fan',
    'fk': '',
    'fl': '',
    'fm': '',
    'fn': '',
    'fo': 'fo',
    'fp': '',
    'fq': '',
    'fr': '',
    'fs': '',
    'ft': '',
    'fu': 'fu',
    'fv': '',
    'fw': '',
    'fx': '',
    'fy': '',
    'fz': 'fei',
    'ga': 'ga',
    'gb': 'gou',
    'gc': '',
    'gd': 'guang',
    'ge': 'ge',
    'gf': 'gen',
    'gg': 'geng',
    'gh': 'gang',
    'gi': '',
    'gj': 'gan',
    'gk': 'gao',
    'gl': 'gai',
    'gm': '',
    'gn': '',
    'go': 'guo',
    'gp': 'gun',
    'gq': '',
    'gr': 'guan',
    'gs': 'gong',
    'gt': '',
    'gu': 'gu',
    'gv': 'gui',
    'gw': 'gua',
    'gx': '',
    'gy': 'guai',
    'gz': 'gei',
    'ha': 'ha',
    'hb': 'hou',
    'hc': '',
    'hd': 'huang',
    'he': 'he',
    'hf': 'hen',
    'hg': 'heng',
    'hh': 'hang',
    'hi': '',
    'hj': 'han',
    'hk': 'hao',
    'hl': 'hai',
    'hm': '',
    'hn': '',
    'ho': 'huo',
    'hp': 'hun',
    'hq': '',
    'hr': 'huan',
    'hs': 'hong',
    'ht': '',
    'hu': 'hu',
    'hv': 'hui',
    'hw': 'hua',
    'hx': '',
    'hy': 'huai',
    'hz': 'hei',
    'ia': 'cha',
    'ib': 'chou',
    'ic': '',
    'id': 'chuang',
    'ie': 'che',
    'if': 'chen',
    'ig': 'cheng',
    'ih': 'chang',
    'ii': 'chi',
    'ij': 'chan',
    'ik': 'chao',
    'il': 'chai',
    'im': '',
    'in': '',
    'io': 'chuo',
    'ip': 'chun',
    'iq': '',
    'ir': 'chuan',
    'is': 'chong',
    'it': '',
    'iu': 'chu',
    'iv': 'chui',
    'iw': 'chua',
    'ix': '',
    'iy': 'chuai',
    'iz': '',
    'ja': '',
    'jb': '',
    'jc': 'jiao',
    'jd': 'jiang',
    'je': '',
    'jf': '',
    'jg': '',
    'jh': '',
    'ji': 'ji',
    'jj': '',
    'jk': '',
    'jl': '',
    'jm': 'jian',
    'jn': 'jin',
    'jo': '',
    'jp': 'jun',
    'jq': 'jiu',
    'jr': 'juan',
    'js': 'jiong',
    'jt': 'jve',
    'ju': 'ju',
    'jv': '',
    'jw': 'jia',
    'jx': 'jie',
    'jy': 'jing',
    'jz': '',
    'ka': 'ka',
    'kb': 'kou',
    'kc': '',
    'kd': 'kuang',
    'ke': 'ke',
    'kf': 'ken',
    'kg': 'keng',
    'kh': 'kang',
    'ki': '',
    'kj': 'kan',
    'kk': 'kao',
    'kl': 'kai',
    'km': '',
    'kn': '',
    'ko': 'kuo',
    'kp': 'kun',
    'kq': '',
    'kr': 'kuan',
    'ks': 'kong',
    'kt': '',
    'ku': 'ku',
    'kv': 'kui',
    'kw': 'kua',
    'kx': '',
    'ky': 'kuai',
    'kz': 'kei',
    'la': 'la',
    'lb': 'lou',
    'lc': 'liao',
    'ld': 'liang',
    'le': 'le',
    'lf': '',
    'lg': 'leng',
    'lh': 'lang',
    'li': 'li',
    'lj': 'lan',
    'lk': 'lao',
    'll': 'lai',
    'lm': 'lian',
    'ln': 'lin',
    'lo': 'luo',
    'lp': 'lun',
    'lq': 'liu',
    'lr': 'luan',
    'ls': 'long',
    'lt': 'lve',
    'lu': 'lu',
    'lv': 'lv',
    'lw': 'lia',
    'lx': 'lie',
    'ly': 'ling',
    'lz': 'lei',
    'ma': 'ma',
    'mb': 'mou',
    'mc': 'miao',
    'md': '',
    'me': 'me',
    'mf': 'men',
    'mg': 'meng',
    'mh': 'mang',
    'mi': 'mi',
    'mj': 'man',
    'mk': 'mao',
    'ml': 'mai',
    'mm': 'mian',
    'mn': 'min',
    'mo': 'mo',
    'mp': '',
    'mq': 'miu',
    'mr': '',
    'ms': '',
    'mt': '',
    'mu': 'mu',
    'mv': '',
    'mw': '',
    'mx': 'mie',
    'my': 'ming',
    'mz': 'mei',
    'na': 'na',
    'nb': 'nou',
    'nc': 'niao',
    'nd': 'niang',
    'ne': 'ne',
    'nf': 'nen',
    'ng': 'neng',
    'nh': 'nang',
    'ni': 'ni',
    'nj': 'nan',
    'nk': 'nao',
    'nl': 'nl',
    'nm': 'nian',
    'nn': 'nin',
    'no': 'nuo',
    'np': 'nun',
    'nq': 'niu',
    'nr': 'nuan',
    'ns': 'nong',
    'nt': 'nve',
    'nu': 'nu',
    'nv': 'nv',
    'nw': 'nia',
    'nx': 'nie',
    'ny': 'ning',
    'nz': 'nz',
    'oa': '',
    'ob': '',
    'oc': '',
    'od': '',
    'oe': '',
    'of': '',
    'og': '',
    'oh': '',
    'oi': '',
    'oj': '',
    'ok': '',
    'ol': '',
    'om': '',
    'on': '',
    'oo': 'o',
    'op': '',
    'oq': '',
    'or': '',
    'os': '',
    'ot': '',
    'ou': 'ou',
    'ov': '',
    'ow': '',
    'ox': '',
    'oy': '',
    'oz': '',
    'pa': 'pa',
    'pb': 'pou',
    'pc': 'piao',
    'pd': '',
    'pe': '',
    'pf': 'pen',
    'pg': 'peng',
    'ph': 'pang',
    'pi': 'pi',
    'pj': 'pan',
    'pk': 'pao',
    'pl': 'pai',
    'pm': 'pian',
    'pn': 'pin',
    'po': 'po',
    'pp': '',
    'pq': '',
    'pr': '',
    'ps': '',
    'pt': '',
    'pu': 'pu',
    'pv': '',
    'pw': '',
    'px': 'pie',
    'py': 'ping',
    'pz': 'pei',
    'qa': '',
    'qb': '',
    'qc': 'qiao',
    'qd': 'qiang',
    'qe': '',
    'qf': '',
    'qg': '',
    'qh': '',
    'qi': 'qi',
    'qj': '',
    'qk': '',
    'ql': '',
    'qm': 'qian',
    'qn': 'qin',
    'qo': '',
    'qp': 'qun',
    'qq': 'qiu',
    'qr': 'quan',
    'qs': 'qiong',
    'qt': 'que',
    'qu': 'qu',
    'qv': '',
    'qw': 'qia',
    'qx': 'qie',
    'qy': 'qing',
    'qz': '',
    'ra': '',
    'rb': 'rou',
    'rc': '',
    'rd': '',
    're': 're',
    'rf': 'ren',
    'rg': 'reng',
    'rh': 'rang',
    'ri': 'ri',
    'rj': 'ran',
    'rk': 'rao',
    'rl': '',
    'rm': '',
    'rn': '',
    'ro': 'ruo',
    'rp': 'run',
    'rq': '',
    'rr': 'ruan',
    'rs': 'rong',
    'rt': '',
    'ru': 'ru',
    'rv': 'rui',
    'rw': 'rua',
    'rx': '',
    'ry': '',
    'rz': '',
    'sa': 'sa',
    'sb': 'sou',
    'sc': '',
    'sd': '',
    'se': 'se',
    'sf': 'sen',
    'sg': 'seng',
    'sh': 'sang',
    'si': 'si',
    'sj': 'san',
    'sk': 'sao',
    'sl': 'sai',
    'sm': '',
    'sn': '',
    'so': 'suo',
    'sp': 'sun',
    'sq': '',
    'sr': 'suan',
    'ss': 'song',
    'st': '',
    'su': 'su',
    'sv': 'sui',
    'sw': '',
    'sx': '',
    'sy': '',
    'sz': 'sei',
    'ta': 'ta',
    'tb': 'tou',
    'tc': 'tiao',
    'td': '',
    'te': 'te',
    'tf': 'ten',
    'tg': 'teng',
    'th': 'tang',
    'ti': 'ti',
    'tj': 'tan',
    'tk': 'tao',
    'tl': 'tai',
    'tm': 'tian',
    'tn': '',
    'to': 'tuo',
    'tp': 'tun',
    'tq': '',
    'tr': 'tuan',
    'ts': 'tong',
    'tt': '',
    'tu': 'tu',
    'tv': 'tui',
    'tw': '',
    'tx': 'tie',
    'ty': 'ting',
    'tz': 'tei',
    'ua': 'sha',
    'ub': 'shou',
    'uc': '',
    'ud': 'shuang',
    'ue': 'she',
    'uf': 'shen',
    'ug': 'sheng',
    'uh': 'shang',
    'ui': 'shi',
    'uj': 'shan',
    'uk': 'shao',
    'ul': 'shai',
    'um': '',
    'un': '',
    'uo': 'shuo',
    'up': 'shun',
    'uq': '',
    'ur': 'shuan',
    'us': 'shong',
    'ut': '',
    'uu': 'shu',
    'uv': 'shui',
    'uw': 'shua',
    'ux': '',
    'uy': 'shuai',
    'uz': 'shei',
    'va': 'zha',
    'vb': 'zhou',
    'vc': '',
    'vd': 'zhuang',
    've': 'zhe',
    'vf': 'zhen',
    'vg': 'zheng',
    'vh': 'zhang',
    'vi': 'zhi',
    'vj': 'zhan',
    'vk': 'zhao',
    'vl': 'zhai',
    'vm': '',
    'vn': '',
    'vo': 'zhuo',
    'vp': 'zhun',
    'vq': '',
    'vr': 'zhuan',
    'vs': 'zhong',
    'vt': '',
    'vu': 'zhu',
    'vv': 'zhui',
    'vw': 'zhua',
    'vx': '',
    'vy': 'zhuai',
    'vz': 'zhei',
    'wa': 'wa',
    'wb': '',
    'wc': '',
    'wd': '',
    'we': '',
    'wf': 'wen',
    'wg': 'weng',
    'wh': 'wang',
    'wi': '',
    'wj': 'wan',
    'wk': '',
    'wl': 'wai',
    'wm': '',
    'wn': '',
    'wo': 'wo',
    'wp': '',
    'wq': '',
    'wr': '',
    'ws': '',
    'wt': '',
    'wu': 'wu',
    'wv': '',
    'ww': '',
    'wx': '',
    'wy': '',
    'wz': 'wei',
    'xa': '',
    'xb': '',
    'xc': 'xiao',
    'xd': 'xiang',
    'xe': '',
    'xf': '',
    'xg': '',
    'xh': '',
    'xi': 'xi',
    'xj': '',
    'xk': '',
    'xl': '',
    'xm': 'xian',
    'xn': 'xin',
    'xo': '',
    'xp': 'xun',
    'xq': 'xiu',
    'xr': 'xuan',
    'xs': 'xiong',
    'xt': 'xue',
    'xu': 'xu',
    'xv': '',
    'xw': 'xia',
    'xx': 'xie',
    'xy': 'xing',
    'xz': '',
    'ya': 'ya',
    'yb': 'you',
    'yc': '',
    'yd': '',
    'ye': 'ye',
    'yf': '',
    'yg': '',
    'yh': 'yang',
    'yi': 'yi',
    'yj': 'yan',
    'yk': 'yao',
    'yl': 'yai',
    'ym': '',
    'yn': 'yin',
    'yo': 'yo',
    'yp': 'yun',
    'yq': '',
    'yr': 'yuan',
    'ys': 'yong',
    'yt': 'yve',
    'yu': 'yu',
    'yv': '',
    'yw': '',
    'yx': '',
    'yy': 'ying',
    'yz': '',
    'za': 'za',
    'zb': 'zou',
    'zc': '',
    'zd': '',
    'ze': 'ze',
    'zf': 'zen',
    'zg': 'zeng',
    'zh': 'zang',
    'zi': 'zi',
    'zj': 'zan',
    'zk': 'zao',
    'zl': 'zai',
    'zm': '',
    'zn': '',
    'zo': 'zuo',
    'zp': 'zun',
    'zq': '',
    'zr': 'zuan',
    'zs': 'zong',
    'zt': '',
    'zu': 'zu',
    'zv': 'zui',
    'zw': '',
    'zx': '',
    'zy': '',
    'zz': 'zei',
}
